<template>
  <div class="container">
    <search-form :initial-query="this.query" @search="searchTriggered" class="search-form"></search-form>

      <div v-if="gifs">
      <transition-group name="fade" class="gifs" v-if="gifs.length > 0">
          <gif-preview v-for="(gif, id) in gifs" :gif="gif" :idx="id" key="id"></gif-preview>
      </transition-group>
      <div v-else>
       <p>Your search <strong>{{query}}</strong> did not match any documents.</p>
       <p>
         Suggestions:
         <ul>
          <li>Make sure that all words are spelled correctly.</li>
          <li>Try different keywords.</li>
          <li>Try more general keywords.</li>
          <li>Try fewer keywords.</li>
         </ul>
       </p>
      </div>
      </div>
  </div>
</template>

<script>
  import GifPreview from '@/components/GifPreview.vue'
  import SearchForm from '@/components/SearchForm.vue'

  export default {
    name: 'search',
    props: ['query'],
    components: {
      GifPreview,
      SearchForm
    },
    data () {
      return {
        gifs: null
      }
    },
    methods: {
      searchTriggered (value) {
        fetch(`http://api.giphy.com/v1/gifs/search?api_key=dc6zaTOxFJmzC&q=${value}&limit=15`)
        .then((response) => response.json())
        .then(({ data }) => { this.gifs = data })
      }
    }
  }
</script>

<style scoped>
  .search-form {
    margin: 1.5rem 0;
  }

  .gifs {
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
  }
</style>
